Index: /documented-examples/trunk/authen-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/authen-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/authen-e/etc/collectionConfig.xml	(revision 38976)
@@ -27,5 +27,4 @@
 	 collectionConfig.properties, in the resources folder of the collection -->
     <displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-    <displayItem assigned="true" lang="en" name="name">Authentication demo</displayItem>
     <displayItem assigned="true" dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
     <displayItem assigned="true" dictionary="collectionConfig" key="description1" name="description1"/>
Index: /documented-examples/trunk/image-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/image-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/image-e/etc/collectionConfig.xml	(revision 38976)
@@ -7,5 +7,4 @@
 	<displayItemList>
 		<displayItem dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem lang="en" name="name">Simple image collection</displayItem>		
 		<displayItem dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
 		<displayItem dictionary="collectionConfig" key="description1" name="description1"/>
Index: /documented-examples/trunk/isis-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/isis-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/isis-e/etc/collectionConfig.xml	(revision 38976)
@@ -8,5 +8,4 @@
 	<displayItemList>
 		<displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem assigned="true" lang="en" name="name">CDS/ISIS example</displayItem>		
 		<displayItem assigned="true" dictionary="collectionConfig" key="description1a" name="description1a"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description1" name="description1"/>
Index: /documented-examples/trunk/lomdemo-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/lomdemo-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/lomdemo-e/etc/collectionConfig.xml	(revision 38976)
@@ -8,5 +8,4 @@
 	<displayItemList>
 		<displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem assigned="true" lang="en" name="name">LOM Demonstration</displayItem>		
 		<displayItem assigned="true" dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description1" name="description1"/>
Index: /documented-examples/trunk/manifest-demo-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/manifest-demo-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/manifest-demo-e/etc/collectionConfig.xml	(revision 38976)
@@ -8,5 +8,4 @@
 	<displayItemList>
 		<displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem assigned="true" lang="en" name="name">manifest-demo-e</displayItem>
 		<displayItem assigned="true" dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description" name="description"/>
Index: /documented-examples/trunk/marc-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/marc-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/marc-e/etc/collectionConfig.xml	(revision 38976)
@@ -8,7 +8,7 @@
 	<displayItemList>
 		<displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem assigned="true" lang="en" name="name">MARC example</displayItem>
 		<displayItem assigned="true" dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description1" name="description1"/>
+		<displayItem assigned="true" dictionary="collectionConfig" key="description1a" name="description1a"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description2" name="description2"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description3" name="description3"/>
Index: /documented-examples/trunk/oai-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/oai-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/oai-e/etc/collectionConfig.xml	(revision 38976)
@@ -8,5 +8,4 @@
 	<displayItemList>
 		<displayItem dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem lang="en" name="name">OAI demo</displayItem>
 		<displayItem dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
 		<displayItem dictionary="collectionConfig" key="description1" name="description1"/>
Index: /documented-examples/trunk/pagedimg-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/pagedimg-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/pagedimg-e/etc/collectionConfig.xml	(revision 38976)
@@ -8,5 +8,4 @@
 	<displayItemList>
 		<displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem assigned="true" lang="en" name="name">Paged Image Example</displayItem>
 		<displayItem assigned="true" dictionary="collectionConfig" key="section_text" name="section_text"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
Index: /documented-examples/trunk/wiki-e/etc/collectionConfig.xml
===================================================================
--- /documented-examples/trunk/wiki-e/etc/collectionConfig.xml	(revision 38975)
+++ /documented-examples/trunk/wiki-e/etc/collectionConfig.xml	(revision 38976)
@@ -9,5 +9,4 @@
 		<displayItem assigned="true" dictionary="collectionConfig" key="description" name="description"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="name" name="name"/>
-		<displayItem assigned="true" lang="en" name="name">MediaWiki collection</displayItem>
 		<displayItem assigned="true" dictionary="collectionConfig" key="shortDescription" name="shortDescription"/>
 		<displayItem assigned="true" dictionary="collectionConfig" key="description1" name="description1"/>