Index: /main/trunk/greenstone3/build.xml
===================================================================
--- /main/trunk/greenstone3/build.xml	(revision 38980)
+++ /main/trunk/greenstone3/build.xml	(revision 38981)
@@ -4882,68 +4882,68 @@
   </target>
     
-	<target name="run-collection-tests">
-		<if><bool><not><available file="${basedir}/ext/testing" type="dir"/></not></bool>
-			<fail>The testing extension is not available. This is required to perform the tests. It can be acquired from SVN by running the command "svn co https://svn.greenstone.org/gs3-extensions/testing/trunk/src testing" in the ext directory of your Greenstone 3 installation. </fail>
-		</if>
-		<for param="testjar">
-			<path>
-				<fileset dir="${basedir}" includes="web/sites/*/collect/*/tests/tests.jar"/>
-			</path>
-			<sequential>
-				<echo>Testing @{testjar}</echo>
-				<java classname="org.junit.runner.JUnitCore" fork="true">
-					<!--https://stackoverflow.com/questions/38676719/selenium-using-java-the-path-to-the-driver-executable-must-be-set-by-the-webdr-->
-					<sysproperty key="webdriver.gecko.driver" path="${basedir}/ext/testing/geckodriver"/>
-					<arg value="gstests.TestClass"/>
-					<jvmarg value="-DSERVERURL=${default.server.protocol}://${tomcat.server}:${default.tomcat.port}${app.path}${server.default.servlet} "/>
-					<classpath>
-						<fileset dir="${basedir}/ext/testing/lib/java">
-							<include name="*.jar"/>
-						</fileset>
-						<files includes="@{testjar}"/>
-					</classpath>
-				</java>
-			</sequential>
-		</for>
-	</target>
-	
-	<target name="build-collection-tests">
-		<if><bool><not><available file="${basedir}/ext/testing" type="dir"/></not></bool>
-			<fail>The testing extension is not available. This is required to perform the tests. It can be acquired from SVN by running the command "svn co https://svn.greenstone.org/gs3-extensions/testing/trunk/src testing" in the ext directory of your Greenstone 3 installation. </fail>
-		</if>
-		<for param="compiledir">
-			<path>
-				<dirset dir="${basedir}" includes="web/sites/*/collect/*/tests/src"/>
-			</path>
-			<sequential>
-				<echo>Compiling @{compiledir}</echo>
-				<if><bool><not><available file="@{compiledir}/../build" type="dir"/></not></bool>
-					<mkdir dir="@{compiledir}/../build"/>
-				</if>
-				<javac srcdir="@{compiledir}" 
-				       destdir="@{compiledir}/../build" 
-				       includeantruntime="${compile.includeantruntime}"
-				       debug="${compile.debug}" 
-				       deprecation="${compile.deprecation}" 
-				       optimize="${compile.optimize}"
+  <target name="run-collection-tests">
+    <if><bool><not><available file="${basedir}/ext/testing" type="dir"/></not></bool>
+    <fail>The testing extension is not available. This is required to perform the tests. It can be acquired from SVN by running the command "svn co https://svn.greenstone.org/gs3-extensions/testing/trunk/src testing" in the ext directory of your Greenstone 3 installation. </fail>
+    </if>
+    <for param="testjar">
+      <path>
+	<fileset dir="${basedir}" includes="web/sites/*/collect/*/tests/tests.jar"/>
+      </path>
+      <sequential>
+	<echo>Testing @{testjar}</echo>
+	<java classname="org.junit.runner.JUnitCore" fork="true">
+	  <!--https://stackoverflow.com/questions/38676719/selenium-using-java-the-path-to-the-driver-executable-must-be-set-by-the-webdr-->
+	  <sysproperty key="webdriver.gecko.driver" path="${basedir}/ext/testing/geckodriver"/>
+	  <arg value="gstests.TestClass"/>
+	  <jvmarg value="-DSERVERURL=${default.server.protocol}://${tomcat.server}:${default.tomcat.port}${app.path}${server.default.servlet} "/>
+	  <classpath>
+	    <fileset dir="${basedir}/ext/testing/lib/java">
+	      <include name="*.jar"/>
+	    </fileset>
+	    <files includes="@{testjar}"/>
+	  </classpath>
+	</java>
+      </sequential>
+    </for>
+  </target>
+  
+  <target name="build-collection-tests">
+    <if><bool><not><available file="${basedir}/ext/testing" type="dir"/></not></bool>
+    <fail>The testing extension is not available. This is required to perform the tests. It can be acquired from SVN by running the command "svn co https://svn.greenstone.org/gs3-extensions/testing/trunk/src testing" in the ext directory of your Greenstone 3 installation. </fail>
+    </if>
+    <for param="compiledir">
+      <path>
+	<dirset dir="${basedir}" includes="web/sites/*/collect/*/tests/src"/>
+      </path>
+      <sequential>
+	<echo>Compiling @{compiledir}</echo>
+	<if><bool><not><available file="@{compiledir}/../build" type="dir"/></not></bool>
+	<mkdir dir="@{compiledir}/../build"/>
+	</if>
+	<javac srcdir="@{compiledir}" 
+	       destdir="@{compiledir}/../build" 
+	       includeantruntime="${compile.includeantruntime}"
+	       debug="${compile.debug}" 
+	       deprecation="${compile.deprecation}" 
+	       optimize="${compile.optimize}"
 				       encoding="${compile.encoding}">
-				  <compilerarg line="${compile.javac.flags}"/>
-				  <classpath>
-				    <fileset dir="${basedir}/ext/testing/lib/java">
-				      <include name="*.jar"/>
-				    </fileset>
-				  </classpath>
-				  <include name="gstests/*.java"/>
-				</javac>
-				<jar destfile="@{compiledir}/../tests.jar">
-					<fileset dir="@{compiledir}/../build">
-						<include name="gstests/**"/>
-					</fileset>
-					<manifest>
-						<attribute name="Built-By" value="${user.name}" />
-					</manifest>
-				</jar>
-			</sequential>
-		</for>
-	</target>
+	  <compilerarg line="${compile.javac.flags}"/>
+	  <classpath>
+	    <fileset dir="${basedir}/ext/testing/lib/java">
+	      <include name="*.jar"/>
+	    </fileset>
+	  </classpath>
+	  <include name="gstests/*.java"/>
+	</javac>
+	<jar destfile="@{compiledir}/../tests.jar">
+	  <fileset dir="@{compiledir}/../build">
+	    <include name="gstests/**"/>
+	  </fileset>
+	  <manifest>
+	    <attribute name="Built-By" value="${user.name}" />
+	  </manifest>
+	</jar>
+      </sequential>
+    </for>
+  </target>
 </project>